stages:
  - build_and_test
  - containerize
  - deploy

build_and_test:
  stage: build_and_test
  tags:
    - lutdevops2023
  image: node:latest
  script:
    - npm install
    - npm run test

containerize:
  stage: containerize
  tags:
    - lutdevops2023
  image: docker:latest
  services:
    - docker:dind
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t registry.gitlab.com/riki.jarvinen/lut-devops-assignment .
    - docker push registry.gitlab.com/riki.jarvinen/lut-devops-assignment

deploy:
  stage: deploy
  tags:
    - lutdevops2023
  script:
    - echo "Deploy to Azure App Service"
  environment:
    name: production enviroment
    url: https://lut-devops-rkj.azurewebsites.net